<script setup>
import AuthenticatedLayout from '@/Layouts/AuthenticatedLayout.vue';
import { Head, Link, useForm } from '@inertiajs/vue3';
import { showFlashMessage } from '@/global_func.js';

</script>

<template>
    <Head title="Dashboard" />

    <AuthenticatedLayout :user="user">
        <div class="container-fluid">

            <!-- Page Heading -->
            <div class="d-sm-flex align-items-center justify-content-between mb-4">
                <h1 class="h3 mb-0 text-gray-800">Absensi</h1>
            </div>

            <div class="row">

                <!-- Area Chart -->
                <div class="col-xl-12">
                    <div class="card border-0  mb-4">
                        <!-- Card Header - Dropdown -->
                        <div class="card-header bg-white py-3 ">
                            <h6 class="m-0 font-weight-bold text-primary">Anda belum absen <span
                                    v-if="Object.keys(absensiList).length > 0">pulang</span> hari ini</h6>
                            <small>Tekan tombol di bawah untuk melakukan absensi</small>

                        </div>
                        <!-- Card Body -->
                        <div class="card-body">
                            <div class="d-flex flex-column justify-content-center align-items-center">
                                <img src="/assets/img/location.svg" alt="" width="250">
                                <button v-if="Object.keys(absensiList).length < 1" @click="absen('check_in')"
                                    class="btn bg-main text-white mt-4">Absen
                                    Masuk</button>
                                <button v-else @click="absen('check_out')" class="btn bg-main text-white mt-4">Absen
                                    Pulang</button>
                            </div>
                        </div>
                    </div>
                </div>


            </div>
            <div class="row">

                <!-- Area Chart -->
                <div class="col-xl-12">
                    <div class="card border-0  mb-4">
                        <!-- Card Header - Dropdown -->
                        <div class="card-header bg-white py-3 ">
                            <h6 class="m-0 font-weight-bold text-primary">Data absen hari ini</h6>
                            <small>Data absen anda hari ini dapat di lihat di bawah ini</small>

                        </div>
                        <!-- Card Body -->
                        <div class="card-body">
                            <template v-if="Object.keys(absensiList).length < 1">
                                <div class="d-flex justify-content-center align-items-center flex-column">
                                    <img src="/assets/img/empty.svg" alt="Image Placeholder" width="100">
                                    <p class="mt-3">Belum ada data absensi</p>
                                </div>
                            </template>
                            <template v-else>
                                <div class="absen-item alert alert-secondary border-0">
                                    <i class="fas fa-home"></i>
                                    <span> {{ " Check in : " + absensiList.check_in }}</span>
                                </div>
                                <div class="absen-item alert alert-secondary border-0">
                                    <i class="fas fa-laptop-house"></i>
                                    <span> {{ " Check out : " + absensiList.check_out }}</span>
                                </div>
                                <div class="absen-item alert alert-secondary border-0">
                                    <i class="fas fa-map"></i>
                                    <span> {{ " Check in : " }} <a target="_blank"
                                            :href="'https://www.google.com/maps/place/' + absensiList.check_in_long_lat"
                                            class="badge badge-primary">lihat</a></span>
                                </div>
                                <div class="absen-item alert alert-secondary border-0">
                                    <i class="fas fa-map"></i>
                                    <span> {{ " Check out : " }}<a target="_blank"
                                            :href="'https://www.google.com/maps/place/' + absensiList.check_out_long_lat"
                                            class="badge badge-primary">lihat</a></span>
                                </div>
                            </template>
                        </div>
                    </div>
                </div>


            </div>
        </div>
    </AuthenticatedLayout>
</template>

<script>
export default {
    props: {
        user: Object,
    },
    data() {
        return {
            absensiList: []
        };
    },
    methods: {
        // Fetch today's attendance data from the server
        fetchTodayAttendance() {
            axios.get('/absensi/today')
                .then(response => {
                    // Update the absensiList data property with the fetched data
                    console.log(response.data)
                    this.absensiList = response.data;
                })
                .catch(error => {
                    console.error('Error fetching attendance data', error);
                });
        },
        absen(status) {

            let parentEl = this;
            // Get user's location using Geolocation API
            navigator.geolocation.getCurrentPosition(function (position) {
                var userLatitude = position.coords.latitude;
                var userLongitude = position.coords.longitude;

                // var userLatitude = '-4.8452207586081';
                // var userLongitude = '119.52363684401216';

                // long lat cv aulia -5.140162345379031, 119.49020574602237

                // Target location coordinates
                var targetLatitude = -5.140162345379031; // Replace with your target latitude
                var targetLongitude = 119.49020574602237; // Replace with your target longitude

                // Calculate distance between user and target location
                var distance = calculateDistance(userLatitude, userLongitude, targetLatitude, targetLongitude);

                // Round distance to the nearest integer

                // Use the calculated distance as needed
                console.log('Distance to target location: ' + distance + ' meters');

                // Store attendance data or perform other actions with the distance
                // ... your code here ...
                // Check if user's location is within range (e.g., 15 kilometers) of target location
                let requirementDistance = 150;
                console.log(distance < requirementDistance);
                if (distance < requirementDistance) {
                    // User's location is within range, store attendance data
                    // ... your code here ...

                    // console.log('Attendance data stored successfully.');

                    axios.post('/absensi/' + status, {
                        lat: userLatitude,
                        long: userLongitude
                    })
                        .then(response => {
                            showFlashMessage(response.data.message);
                            if (response.data.absensi) {
                                parentEl.absensiList = response.data.absensi;
                            }
                            // Handle success response
                            console.log('Data stored successfully', response);
                        })
                        .catch(error => {
                            // Handle error response
                            console.error('Error storing data', error);
                        });

                } else {
                    // User's location is outside of range
                    console.log('User is not within range of the target location.');

                    showFlashMessage(
                        'lokasi anda berada: ' +
                        Number(Math.floor(distance)).toLocaleString() +
                        ' meter dari kantor mohon mendekat ke jarak kurang dari 1 meter dari kantor'
                    );
                }

            }, function (error) {
                // Error handling for geolocation
                console.error('Error getting user location:', error);
            });

            // Helper function to calculate distance between two points using Haversine formula
            function calculateDistance(lat1, lon1, lat2, lon2) {
                var earthRadius = 6371; // Radius of the Earth in km
                var latDiff = deg2rad(lat2 - lat1);
                var lonDiff = deg2rad(lon2 - lon1);
                var a = Math.sin(latDiff / 2) * Math.sin(latDiff / 2) +
                    Math.cos(deg2rad(lat1)) * Math.cos(deg2rad(lat2)) *
                    Math.sin(lonDiff / 2) * Math.sin(lonDiff / 2);
                var c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
                var distance = earthRadius * c * 1000; // Distance in meters
                return distance;
            }

            // Helper function to convert degrees to radians
            function deg2rad(deg) {
                return deg * (Math.PI / 180);
            }
        }
    },
    // Call the fetchTodayAttendance method when the component is created
    created() {
        this.fetchTodayAttendance();
    }
}
</script>
